/* 'kelvin.sck' dosyasnda bulunan 100 adet kelvin cinsinden scaklk
   bilgilerini derece karlklarn 'derece.sck' dosyasna yazar.
   Bu iki scaklk arasndaki evrim kural: K = 273 + C eklindedir. */

#include <stdio.h>
#include <stdlib.h>

int main(void)
{
   /* dosya gstericileri  */
   FILE *oku, *yaz;

   /* Dosya adlar */
   char *kaynak_dosya = "kelvin.sck";
   char *hedef_dosya = "derece.sck";

   float K,D;
   int   i=0, n=100;


   /* Dosyalara eriim mmkn m ? */
   if( (oku=fopen(kaynak_dosya, "r")) == NULL )
   {
     printf("%s dosyas acilmadi.\n", kaynak_dosya);
     exit(1);
   }
   if( (yaz=fopen(hedef_dosya, "w")) == NULL )
   {
     printf("%s acilmadi.\n", hedef_dosya);
     exit(2);
   }

   for(i=0; i<n; i++)
   {
      fscanf(oku,"%f",&K);         /* 'kelvin.sck'dan verileri oku     */
      D = K - 273.0;               /* dnm denklemi */
      fprintf(yaz,"%8.2f\n",D);    /* verileri 'derece.sck'ya yaz     */
   }

   /* Dosyalar kapat */
   fclose(oku);
   fclose(yaz);

   printf("%s > %s\n", kaynak_dosya, hedef_dosya);
   puts("cevirme islemi tamamlandi.");
   getche();
 return 0;
}
